import 'dart:async';

import 'package:matrix_sdk/matrix_sdk.dart';
import 'package:url/url.dart';

void main() async {
  final homeserver = Homeserver(Url.parse('https://pattle.im'));

  final user = await homeserver.login(
    Username('pat'),
    'pattle',
    store: MemoryStore(),
  );

  StreamSubscription sub;
  sub = user.sync.listen((syncState) async {
    for (Room room in await user.rooms.get()) {
      print(room.name);
    }
    user.stopSync();
    await sub.cancel();
  });

  await user.startSync();
}
