// Copyright (C) 2019  Wilko Manger
// Copyright (C) 2019  Mathieu Velten
//
// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at http://mozilla.org/MPL/2.0/.\
import 'dart:async';

import 'package:chopper/chopper.dart';

class AccessTokenInterceptor implements RequestInterceptor {
  final String accessToken;

  AccessTokenInterceptor(this.accessToken);

  @override
  FutureOr<Request> onRequest(Request request) {
    final headers = Map<String, String>.from(request.headers);
    headers['Authorization'] = 'Bearer ${accessToken}';

    return request.replace(headers: headers);
  }
}
