// Copyright (C) 2019  Wilko Manger
//
// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at http://mozilla.org/MPL/2.0/.

import 'package:matrix_sdk/src/event/room/room_event.dart';
import 'package:matrix_sdk/src/event/room/state/state_event.dart';
import 'package:meta/meta.dart';

class RoomNameChangeEvent extends StateEvent {
  @override
  final RoomNameChange content;

  RoomNameChangeEvent(this.content, RoomEventArgs args)
      : super(args, stateKey: '');

  factory RoomNameChangeEvent.fromJson(RoomEventArgs args, dynamic json) {
    if (!hasStateKey(json)) {
      return null;
    }

    var name = json['content']['name'];
    return RoomNameChangeEvent(
      RoomNameChange(name: name),
      args,
    );
  }
}

class RoomNameChange extends StateEventContent {
  final String name;

  RoomNameChange({@required this.name});

  @override
  Map<String, dynamic> toJson() => super.toJson()
    ..addAll({
      'name': name,
    });
}
