// Copyright (C) 2019  Wilko Manger
//
// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at http://mozilla.org/MPL/2.0/.

import 'package:matrix_sdk/src/event/event.dart';
import 'package:matrix_sdk/src/event/room/room_event.dart';

abstract class StateEvent extends RoomEvent {
  @override
  StateEventContent get content;

  final String stateKey;

  StateEvent(RoomEventArgs args, {this.stateKey = ''}) : super(args);

  @override
  Map<String, dynamic> toJson() =>
      super.toJson()..addAll({'state_key': stateKey});
}

abstract class StateEventContent extends EventContent {
  final String stateKey = '';
}

/// @internal
bool hasStateKey(dynamic json) => json.containsKey('state_key');
