// Copyright (C) 2019  Wilko Manger
//
// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at http://mozilla.org/MPL/2.0/.

import 'package:chopper/chopper.dart';
import 'package:matrix_sdk/src/api/client.dart';
import 'package:matrix_sdk/src/api/exception_interceptor.dart';
import 'package:matrix_sdk/src/api/media.dart';
import 'package:meta/meta.dart';
import 'package:url/url.dart';
import 'package:http/http.dart' as http;

ChopperClient createChopper({
  @required Url url,
  http.Client client,
  List<dynamic> interceptors,
}) {
  if (interceptors == null) {
    interceptors = [];
  }

  interceptors.add(ExceptionInterceptor());

  return ChopperClient(
    client: client,
    baseUrl: url.toString(),
    services: [ClientService.create(), MediaService.create()],
    interceptors: interceptors,
  );
}
